﻿using System.Drawing;
using System.Windows.Forms;

// https://stackoverflow.com/questions/3399666/mousewheel-event-with-picturebox

namespace PictureBoxMouseWheel
{
    public partial class Form1 : Form
    {
        // Werte zur Anzeige in den Controls
        private int _Rtb = 0;
        private int _Pb = 0;
        private int _Pnl = 0;
        private int _Lbl = 0;

        public Form1()
        {
            this.InitializeComponent();
            // ein Control, das auf MouseWheel reagiert
            this.MouseWheel += this.Global_MouseWheel;
            this.richTextBox1.MouseWheel += this.richTextBox1_MouseWheel;
        }

        private void richTextBox1_MouseWheel(object sender, MouseEventArgs e)
        {
            // Berechnung der Zählwerte
            if (e.Delta > 0) { this._Rtb++; }
            else { this._Rtb--; }
            // Ausgabe des Zählwertes
            this.richTextBox1.Text = this._Rtb.ToString();
        }

        private void pictureBox1_Paint(object sender, PaintEventArgs e)
        {
            // Ausgabe des Zählwertes
            e.Graphics.DrawString(this._Pb.ToString(), this.Font, Brushes.Black, new Point(20, 20));
        }

        private void panel1_Paint(object sender, PaintEventArgs e)
        {
            // Ausgabe des Zählwertes
            e.Graphics.DrawString(this._Pnl.ToString(), this.Font, Brushes.Black, new Point(20, 20));
        }

        /// <summary>
        /// Verteilen des MouseWheel-Events an passive Controls
        /// </summary>
        private void Global_MouseWheel(object sender, MouseEventArgs e)
        {
            if (this.CheckMousePos(this.pictureBox1))
            {
                // Berechnung der Zählwerte
                if (e.Delta > 0) { this._Pb++; }
                else { this._Pb--; }
                this.pictureBox1.Invalidate();
            }
            else if (this.CheckMousePos(this.panel1))
            {
                // Berechnung der Zählwerte
                if (e.Delta > 0) { this._Pnl++; }
                else { this._Pnl--; }
                this.panel1.Invalidate();
            }
            else if (this.CheckMousePos(this.label1))
            {
                // Berechnung der Zählwerte
                if (e.Delta > 0) { this._Lbl++; }
                else { this._Lbl--; }
                // Ausgabe des Zählwertes
                this.label1.Text = this._Lbl.ToString();
            }
        }

        /// <summary>
        /// Testen, ob die Maus auf dem gegebenen Control ist
        /// </summary>
        private bool CheckMousePos(Control ctrl)
        {
            // Do not use MouseEventArgs.X, Y because they are relative!
            Point mousePos = Control.MousePosition;
            do
            {
                Rectangle rect = ctrl.RectangleToScreen(ctrl.ClientRectangle);
                if (!rect.Contains(mousePos))
                {
                    return false; // mouse position is outside the control or it's parents
                }
                ctrl = ctrl.Parent;
            }
            while (ctrl != null && ctrl != this);

            // here you have the mouse position relative to the control if you need it
            return true;
        }
    }
}
